set(DEAL_II_GIT_REVISION "@DEAL_II_GIT_REVISION@")
set(DEAL_II_GIT_SHORTREV "@DEAL_II_GIT_SHORTREV@")
set(DEAL_II_GIT_TAG "@DEAL_II_GIT_TAG@")
+set(DEAL_II_GIT_FANCY_TAG "@DEAL_II_GIT_FANCY_TAG@")
message(STATUS "Could not locate get_latest_tag.sh. " ${_prefix}GIT_TAG " will not be set.")
endif()
+ #
+ # Query for fancy tag:
+ #
+ set(_script "")
+ if(EXISTS ${CMAKE_BINARY_DIR}/${DEAL_II_SHARE_RELDIR}/scripts/get_fancy_tag.sh)
+ set(_script ${CMAKE_BINARY_DIR}/${DEAL_II_SHARE_RELDIR}/scripts/get_fancy_tag.sh)
+ elseif(EXISTS ${DEAL_II_PATH}/${DEAL_II_SHARE_RELDIR}/scripts/get_fancy_tag.sh)
+ set(_script ${DEAL_II_PATH}/${DEAL_II_SHARE_RELDIR}/scripts/get_fancy_tag.sh)
+ endif()
+ if(NOT "${_script}" STREQUAL "")
+ execute_process(
+ COMMAND ${_script}
+ WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
+ OUTPUT_VARIABLE _fancy_tag
+ RESULT_VARIABLE _result
+ OUTPUT_STRIP_TRAILING_WHITESPACE
+ )
+ if(${_result} EQUAL 0)
+ set(${_prefix}GIT_FANCY_TAG ${_fancy_tag})
+ endif()
+ else()
+ message(STATUS "Could not locate get_fancy_tag.sh. " ${_prefix}GIT_FANCY_TAG " will not be set.")
+ endif()
+
endif()
endmacro()
${CMAKE_CURRENT_SOURCE_DIR}/run_test.sh
${CMAKE_CURRENT_SOURCE_DIR}/get_closest_tag.sh
${CMAKE_CURRENT_SOURCE_DIR}/get_latest_tag.sh
+ ${CMAKE_CURRENT_SOURCE_DIR}/get_fancy_tag.sh
)
file(COPY ${_scripts}
DESTINATION ${CMAKE_BINARY_DIR}/${DEAL_II_SHARE_RELDIR}/scripts
--- /dev/null
+#!/bin/sh
+#
+# Find the latest TAG that has a common ancestry (of positive distance) with
+# current HEAD and append the number of commits and commit ID like `git describe`
+# does.
+#
+
+if ! git --version | grep -q "git version 2"; then
+ # This script requires version 2 or newer
+ exit 1
+fi
+
+head="$(git rev-parse HEAD)"
+
+tags="$(git tag --sort=-creatordate)"
+
+for tag in $tags; do
+ tag_commit="$(git rev-parse $tag^{commit})"
+
+ if [ "$tag_commit" = "$head" ]; then
+ echo "$tag"
+ exit 0;
+ fi
+
+ ancestor="$(git merge-base HEAD $tag)"
+
+ if [ "$ancestor" != "$head" ]; then
+ echo "$tag-$(git rev-list $(git describe --tags --abbrev=0)..HEAD --count)-g$(git rev-parse --short HEAD)"
+ exit 0;
+ fi
+done
+
+exit 1
*/
#define DEAL_II_GIT_SHORTREV "@DEAL_II_GIT_SHORTREV@"
+/**
+ * Tag of the current git HEAD.
+ */
+#define DEAL_II_GIT_TAG "@DEAL_II_GIT_TAG@"
+
+/**
+ * Fancy tag of the current git HEAD.
+ */
+#define DEAL_II_GIT_FANCY_TAG "@DEAL_II_GIT_FANCY_TAG@"
+
#endif